Syntax
Argument
Description
text
(Required) The text to be tested against the regular_expression.You can input a string like “text“, a cell reference like “C4”, or a cell range reference like “C4: D4“ (work in dynamic array)
regular_expression
(Required) The regular expression to test the text against.You can input a string like “[0-9]+“,or a cell reference like “C4“.
modifiers
The modifiers to define the pattern. You can input a string like “gi“, or a cell reference like “C4“.
Modifiers
Modifier
Name
Description
g
global
Retain the index of the last match, allowing subsequent searches to start from the end of the previous match.Without the global flag, subsequent searches will return the same match.
i
ignore case
Makes the whole expression case-insensitive.For example, /aBc/i would match AbC.
m
multiline
When the multiline flag is enabled, beginning and end anchors (^ and \$) will match the start and end of a line, instead of the start and end of the whole string.Note that patterns such as /^[\s\S]+$/m may return matches that span multiple lines because the anchors will match the start/end of any line.
u
unicode
When the unicode flag is enabled, you can use extended unicode escapes in the form \x{FFFFF}.It also makes other escapes stricter, causing unrecognized escapes (ex. \j) to throw an error.
y
sticky
The expression will only match from its lastIndex position and ignores the global (g) flag if set. Because each search in RegExr is discrete, this flag has no further impact on the displayed results.
s
dotAll
Dot (.) will match any character, including newline.
Please make sure your browser supports the modifiers you use.
The modifier “y“ is not supported in SJS because sticky will lead to inconsistent calculation results.If modifier “y“ is set, it will be ignored in the calculation.
Samples
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
spread.options.highlightInvalidData = true;
var sheet = spread.sheets[0];
var defaultStyle = new GC.Spread.Sheets.Style();
defaultStyle.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
defaultStyle.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setDefaultStyle(defaultStyle);
sheet.setColumnWidth(0, 250);
sheet.setColumnWidth(1, 250);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 250);
sheet.setColumnWidth(4, 150);
sheet.addSpan(0, 0, 2, 5);
sheet.getCell(0, 0).value("Conditional Format").font("21px bold normal normal");
initRange(sheet, 2);
var EQUAL_TO = GC.Spread.Sheets.ConditionalFormatting.ComparisonOperators.equalsTo;
var CONDITION_RANGE = [new GC.Spread.Sheets.Range(4, 4, 4, 1)];
var true_style = new GC.Spread.Sheets.Style();
true_style.backColor = 'lightgreen';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, true, undefined, true_style, CONDITION_RANGE);
var false_style = new GC.Spread.Sheets.Style();
false_style.backColor = 'pink';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, false, undefined, false_style, CONDITION_RANGE);
sheet.addSpan(8, 0, 2, 5);
sheet.getCell(8, 0).value("Data Validation").font("21px bold normal normal");
initRange(sheet, 10);
createDataValidations(sheet, 12);
createDataValidations(sheet, 13);
createDataValidations(sheet, 14);
spread.resumePaint();
}
function initRange(sheet, baseRow) {
sheet.addSpan(baseRow, 0, 2, 1);
sheet.addSpan(baseRow, 1, 2, 1);
sheet.addSpan(baseRow, 2, 2, 1);
sheet.addSpan(baseRow, 3, 2, 1);
sheet.addSpan(baseRow, 4, 2, 1);
sheet.getCell(baseRow, 0).value("Text").font("21px bold normal normal");
sheet.getCell(baseRow, 1).value("Regular Expression").font("21px bold normal normal");
sheet.getCell(baseRow, 2).value("Modifiers").font("21px bold normal normal");
sheet.getCell(baseRow, 3).value("Formula Text").font("21px bold normal normal");
sheet.getCell(baseRow, 4).value("Result").font("21px bold normal normal");
var dataArr = [["SpreadJS Supports 400 functions.", "\\d+", ""],
["My Name is (John Smith)", "\\(([\\w ]+)\\)", ""],
["Red", "[^red]", "i"]];
sheet.setArray(2 + baseRow, 0, dataArr);
for (var i = baseRow, len = dataArr.length; i < len + baseRow; i++) {
var row = 3 + i;
sheet.setFormula(row - 1, 4, `=SJS.REGEXMATCH(A${row}, B${row}, C${row})`);
sheet.setFormula(row - 1, 3, `=FORMULATEXT(E${row})`);
}
}
function createDataValidations (sheet, row) {
var false_dv = GC.Spread.Sheets.DataValidation.createFormulaValidator("IF(E" + (row + 1) + ",TRUE,FALSE)");
false_dv.highlightStyle({type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar, color: "pink", position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft});
sheet.setDataValidator(row, 4, 1, 1, false_dv, 3);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
</div>
</body>
</html>
input[type="text"] {
width: 200px;
margin-right: 20px;
}
label {
display: inline-block;
width: 110px;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
code {
border: 1px solid #000;
}

Syntax
Argument
Description
text
(Required) The text to be tested against the regular_expression.You can input a string like “text“, a cell reference like “C4”, or a cell range reference like “C4: D4“ (work in dynamic array)
regular_expression
(Required) The regular expression to test the text against.You can input a string like “[0-9]+“,or a cell reference like “C4“.
modifiers
The modifiers to define the pattern. You can input a string like “gi“, or a cell reference like “C4“.
Modifiers
Modifier
Name
Description
g
global
Retain the index of the last match, allowing subsequent searches to start from the end of the previous match.Without the global flag, subsequent searches will return the same match.
i
ignore case
Makes the whole expression case-insensitive.For example, /aBc/i would match AbC.
m
multiline
When the multiline flag is enabled, beginning and end anchors (^ and \$) will match the start and end of a line, instead of the start and end of the whole string.Note that patterns such as /^[\s\S]+$/m may return matches that span multiple lines because the anchors will match the start/end of any line.
u
unicode
When the unicode flag is enabled, you can use extended unicode escapes in the form \x{FFFFF}.It also makes other escapes stricter, causing unrecognized escapes (ex. \j) to throw an error.
y
sticky
The expression will only match from its lastIndex position and ignores the global (g) flag if set. Because each search in RegExr is discrete, this flag has no further impact on the displayed results.
s
dotAll
Dot (.) will match any character, including newline.
Please make sure your browser supports the modifiers you use.
The modifier “y“ is not supported in SJS because sticky will lead to inconsistent calculation results.If modifier “y“ is set, it will be ignored in the calculation.
Samples
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
spread.options.highlightInvalidData = true;
var sheet = spread.sheets[0];
var defaultStyle = new GC.Spread.Sheets.Style();
defaultStyle.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
defaultStyle.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setDefaultStyle(defaultStyle);
sheet.setColumnWidth(0, 250);
sheet.setColumnWidth(1, 250);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 250);
sheet.setColumnWidth(4, 150);
sheet.addSpan(0, 0, 2, 5);
sheet.getCell(0, 0).value("Conditional Format").font("21px bold normal normal");
initRange(sheet, 2);
var EQUAL_TO = GC.Spread.Sheets.ConditionalFormatting.ComparisonOperators.equalsTo;
var CONDITION_RANGE = [new GC.Spread.Sheets.Range(4, 4, 4, 1)];
var true_style = new GC.Spread.Sheets.Style();
true_style.backColor = 'lightgreen';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, true, undefined, true_style, CONDITION_RANGE);
var false_style = new GC.Spread.Sheets.Style();
false_style.backColor = 'pink';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, false, undefined, false_style, CONDITION_RANGE);
sheet.addSpan(8, 0, 2, 5);
sheet.getCell(8, 0).value("Data Validation").font("21px bold normal normal");
initRange(sheet, 10);
createDataValidations(sheet, 12);
createDataValidations(sheet, 13);
createDataValidations(sheet, 14);
spread.resumePaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>
);
}
function initRange(sheet, baseRow) {
sheet.addSpan(baseRow, 0, 2, 1);
sheet.addSpan(baseRow, 1, 2, 1);
sheet.addSpan(baseRow, 2, 2, 1);
sheet.addSpan(baseRow, 3, 2, 1);
sheet.addSpan(baseRow, 4, 2, 1);
sheet.getCell(baseRow, 0).value("Text").font("21px bold normal normal");
sheet.getCell(baseRow, 1).value("Regular Expression").font("21px bold normal normal");
sheet.getCell(baseRow, 2).value("Modifiers").font("21px bold normal normal");
sheet.getCell(baseRow, 3).value("Formula Text").font("21px bold normal normal");
sheet.getCell(baseRow, 4).value("Result").font("21px bold normal normal");
var dataArr = [["SpreadJS Supports 400 functions.", "\\d+", ""],
["My Name is (John Smith)", "\\(([\\w ]+)\\)", ""],
["Red", "[^red]", "i"]];
sheet.setArray(2 + baseRow, 0, dataArr);
for (var i = baseRow, len = dataArr.length; i < len + baseRow; i++) {
var row = 3 + i;
sheet.setFormula(row - 1, 4, `=SJS.REGEXMATCH(A${row}, B${row}, C${row})`);
sheet.setFormula(row - 1, 3, `=FORMULATEXT(E${row})`);
}
}
function createDataValidations(sheet, row) {
var false_dv = GC.Spread.Sheets.DataValidation.createFormulaValidator("IF(E" + (row + 1) + ",TRUE,FALSE)");
false_dv.highlightStyle({ type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar, color: "pink", position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft });
sheet.setDataValidator(row, 4, 1, 1, false_dv, 3);
}
import * as React from 'react';
import {SpreadSheets, Worksheet} from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.options.highlightInvalidData = true;
var sheet = spread.sheets[0];
var defaultStyle = new GC.Spread.Sheets.Style();
defaultStyle.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
defaultStyle.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setDefaultStyle(defaultStyle);
sheet.setColumnWidth(0, 250);
sheet.setColumnWidth(1, 250);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 250);
sheet.setColumnWidth(4, 150);
sheet.addSpan(0, 0, 2, 5);
sheet.getCell(0, 0).value("Conditional Format").font("21px bold normal normal");
initRange(sheet, 2);
var EQUAL_TO = GC.Spread.Sheets.ConditionalFormatting.ComparisonOperators.equalsTo;
var CONDITION_RANGE = [new GC.Spread.Sheets.Range(4, 4, 4, 1)];
var true_style = new GC.Spread.Sheets.Style();
true_style.backColor = 'lightgreen';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, true, undefined, true_style, CONDITION_RANGE);
var false_style = new GC.Spread.Sheets.Style();
false_style.backColor = 'pink';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, false, undefined, false_style, CONDITION_RANGE);
sheet.addSpan(8, 0, 2, 5);
sheet.getCell(8, 0).value("Data Validation").font("21px bold normal normal");
initRange(sheet, 10);
createDataValidations(sheet, 12);
createDataValidations(sheet, 13);
createDataValidations(sheet, 14);
spread.resumePaint();
}
}
function initRange(sheet, baseRow) {
sheet.addSpan(baseRow, 0, 2, 1);
sheet.addSpan(baseRow, 1, 2, 1);
sheet.addSpan(baseRow, 2, 2, 1);
sheet.addSpan(baseRow, 3, 2, 1);
sheet.addSpan(baseRow, 4, 2, 1);
sheet.getCell(baseRow, 0).value("Text").font("21px bold normal normal");
sheet.getCell(baseRow, 1).value("Regular Expression").font("21px bold normal normal");
sheet.getCell(baseRow, 2).value("Modifiers").font("21px bold normal normal");
sheet.getCell(baseRow, 3).value("Formula Text").font("21px bold normal normal");
sheet.getCell(baseRow, 4).value("Result").font("21px bold normal normal");
var dataArr = [["SpreadJS Supports 400 functions.", "\\d+", ""],
["My Name is (John Smith)", "\\(([\\w ]+)\\)", ""],
["Red", "[^red]", "i"]];
sheet.setArray(2 + baseRow, 0, dataArr);
for (var i = baseRow, len = dataArr.length; i < len + baseRow; i++) {
var row = 3 + i;
sheet.setFormula(row - 1, 4, `=SJS.REGEXMATCH(A${row}, B${row}, C${row})`);
sheet.setFormula(row - 1, 3, `=FORMULATEXT(E${row})`);
}
}
function createDataValidations (sheet, row) {
var false_dv = GC.Spread.Sheets.DataValidation.createFormulaValidator("IF(E" + (row + 1) + ",TRUE,FALSE)");
false_dv.highlightStyle({type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar, color: "pink", position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft});
sheet.setDataValidator(row, 4, 1, 1, false_dv, 3);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
input {
padding: 4px 6px;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Syntax
Argument
Description
text
(Required) The text to be tested against the regular_expression.You can input a string like “text“, a cell reference like “C4”, or a cell range reference like “C4: D4“ (work in dynamic array)
regular_expression
(Required) The regular expression to test the text against.You can input a string like “[0-9]+“,or a cell reference like “C4“.
modifiers
The modifiers to define the pattern. You can input a string like “gi“, or a cell reference like “C4“.
Modifiers
Modifier
Name
Description
g
global
Retain the index of the last match, allowing subsequent searches to start from the end of the previous match.Without the global flag, subsequent searches will return the same match.
i
ignore case
Makes the whole expression case-insensitive.For example, /aBc/i would match AbC.
m
multiline
When the multiline flag is enabled, beginning and end anchors (^ and \$) will match the start and end of a line, instead of the start and end of the whole string.Note that patterns such as /^[\s\S]+$/m may return matches that span multiple lines because the anchors will match the start/end of any line.
u
unicode
When the unicode flag is enabled, you can use extended unicode escapes in the form \x{FFFFF}.It also makes other escapes stricter, causing unrecognized escapes (ex. \j) to throw an error.
y
sticky
The expression will only match from its lastIndex position and ignores the global (g) flag if set. Because each search in RegExr is discrete, this flag has no further impact on the displayed results.
s
dotAll
Dot (.) will match any character, including newline.
Please make sure your browser supports the modifiers you use.
The modifier “y“ is not supported in SJS because sticky will lead to inconsistent calculation results.If modifier “y“ is set, it will be ignored in the calculation.
Samples
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {}
initSpread($event: any) {
let spread = this.spread = $event.spread;
spread.suspendPaint();
spread.options.highlightInvalidData = true;
var sheet = spread.sheets[0];
var defaultStyle = new GC.Spread.Sheets.Style();
defaultStyle.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
defaultStyle.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setDefaultStyle(defaultStyle);
sheet.setColumnWidth(0, 250);
sheet.setColumnWidth(1, 250);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 250);
sheet.setColumnWidth(4, 150);
sheet.addSpan(0, 0, 2, 5);
sheet.getCell(0, 0).value("Conditional Format").font("21px bold normal normal");
initRange(sheet, 2);
var EQUAL_TO = GC.Spread.Sheets.ConditionalFormatting.ComparisonOperators.equalsTo;
var CONDITION_RANGE = [new GC.Spread.Sheets.Range(4, 4, 4, 1)];
var true_style = new GC.Spread.Sheets.Style();
true_style.backColor = 'lightgreen';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, true, undefined, true_style, CONDITION_RANGE);
var false_style = new GC.Spread.Sheets.Style();
false_style.backColor = 'pink';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, false, undefined, false_style, CONDITION_RANGE);
sheet.addSpan(8, 0, 2, 5);
sheet.getCell(8, 0).value("Data Validation").font("21px bold normal normal");
initRange(sheet, 10);
createDataValidations(sheet, 12);
createDataValidations(sheet, 13);
createDataValidations(sheet, 14);
spread.resumePaint();
}
}
function initRange(sheet, baseRow) {
sheet.addSpan(baseRow, 0, 2, 1);
sheet.addSpan(baseRow, 1, 2, 1);
sheet.addSpan(baseRow, 2, 2, 1);
sheet.addSpan(baseRow, 3, 2, 1);
sheet.addSpan(baseRow, 4, 2, 1);
sheet.getCell(baseRow, 0).value("Text").font("21px bold normal normal");
sheet.getCell(baseRow, 1).value("Regular Expression").font("21px bold normal normal");
sheet.getCell(baseRow, 2).value("Modifiers").font("21px bold normal normal");
sheet.getCell(baseRow, 3).value("Formula Text").font("21px bold normal normal");
sheet.getCell(baseRow, 4).value("Result").font("21px bold normal normal");
var dataArr = [["SpreadJS Supports 400 functions.", "\\d+", ""],
["My Name is (John Smith)", "\\(([\\w ]+)\\)", ""],
["Red", "[^red]", "i"]];
sheet.setArray(2 + baseRow, 0, dataArr);
for (var i = baseRow, len = dataArr.length; i < len + baseRow; i++) {
var row = 3 + i;
sheet.setFormula(row - 1, 4, `=SJS.REGEXMATCH(A${row}, B${row}, C${row})`);
sheet.setFormula(row - 1, 3, `=FORMULATEXT(E${row})`);
}
}
function createDataValidations (sheet, row) {
var false_dv = GC.Spread.Sheets.DataValidation.createFormulaValidator("IF(E" + (row + 1) + ",TRUE,FALSE)");
false_dv.highlightStyle({type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar, color: "pink", position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft});
sheet.setDataValidator(row, 4, 1, 1, false_dv, 3);
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
display: inline-block;
}
input[type="text"] {
width: 200px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Syntax
Argument
Description
text
(Required) The text to be tested against the regular_expression.You can input a string like “text“, a cell reference like “C4”, or a cell range reference like “C4: D4“ (work in dynamic array)
regular_expression
(Required) The regular expression to test the text against.You can input a string like “[0-9]+“,or a cell reference like “C4“.
modifiers
The modifiers to define the pattern. You can input a string like “gi“, or a cell reference like “C4“.
Modifiers
Modifier
Name
Description
g
global
Retain the index of the last match, allowing subsequent searches to start from the end of the previous match.Without the global flag, subsequent searches will return the same match.
i
ignore case
Makes the whole expression case-insensitive.For example, /aBc/i would match AbC.
m
multiline
When the multiline flag is enabled, beginning and end anchors (^ and \$) will match the start and end of a line, instead of the start and end of the whole string.Note that patterns such as /^[\s\S]+$/m may return matches that span multiple lines because the anchors will match the start/end of any line.
u
unicode
When the unicode flag is enabled, you can use extended unicode escapes in the form \x{FFFFF}.It also makes other escapes stricter, causing unrecognized escapes (ex. \j) to throw an error.
y
sticky
The expression will only match from its lastIndex position and ignores the global (g) flag if set. Because each search in RegExr is discrete, this flag has no further impact on the displayed results.
s
dotAll
Dot (.) will match any character, including newline.
Please make sure your browser supports the modifiers you use.
The modifier “y“ is not supported in SJS because sticky will lead to inconsistent calculation results.If modifier “y“ is set, it will be ignored in the calculation.
Samples
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
let initSpread = function (spread) {
spreadRef.value = spread;
spread.suspendPaint();
spread.options.highlightInvalidData = true;
let sheet = spread.sheets[0];
let defaultStyle = new GC.Spread.Sheets.Style();
defaultStyle.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
defaultStyle.vAlign = GC.Spread.Sheets.VerticalAlign.center;
sheet.setDefaultStyle(defaultStyle);
sheet.setColumnWidth(0, 250);
sheet.setColumnWidth(1, 250);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 250);
sheet.setColumnWidth(4, 150);
sheet.addSpan(0, 0, 2, 5);
sheet.getCell(0, 0).value("Conditional Format").font("21px bold normal normal");
initRange(sheet, 2);
let EQUAL_TO = GC.Spread.Sheets.ConditionalFormatting.ComparisonOperators.equalsTo;
let CONDITION_RANGE = [new GC.Spread.Sheets.Range(4, 4, 4, 1)];
let true_style = new GC.Spread.Sheets.Style();
true_style.backColor = 'lightgreen';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, true, undefined, true_style, CONDITION_RANGE);
let false_style = new GC.Spread.Sheets.Style();
false_style.backColor = 'pink';
sheet.conditionalFormats.addCellValueRule(EQUAL_TO, false, undefined, false_style, CONDITION_RANGE);
sheet.addSpan(8, 0, 2, 5);
sheet.getCell(8, 0).value("Data Validation").font("21px bold normal normal");
initRange(sheet, 10);
createDataValidations(sheet, 12);
createDataValidations(sheet, 13);
createDataValidations(sheet, 14);
spread.resumePaint();
}
let initRange = function (sheet, baseRow) {
sheet.addSpan(baseRow, 0, 2, 1);
sheet.addSpan(baseRow, 1, 2, 1);
sheet.addSpan(baseRow, 2, 2, 1);
sheet.addSpan(baseRow, 3, 2, 1);
sheet.addSpan(baseRow, 4, 2, 1);
sheet.getCell(baseRow, 0).value("Text").font("21px bold normal normal");
sheet.getCell(baseRow, 1).value("Regular Expression").font("21px bold normal normal");
sheet.getCell(baseRow, 2).value("Modifiers").font("21px bold normal normal");
sheet.getCell(baseRow, 3).value("Formula Text").font("21px bold normal normal");
sheet.getCell(baseRow, 4).value("Result").font("21px bold normal normal");
let dataArr = [["SpreadJS Supports 400 functions.", "\\d+", ""],
["My Name is (John Smith)", "\\(([\\w ]+)\\)", ""],
["Red", "[^red]", "i"]];
sheet.setArray(2 + baseRow, 0, dataArr);
for (let i = baseRow, len = dataArr.length; i < len + baseRow; i++) {
let row = 3 + i;
sheet.setFormula(row - 1, 4, `=SJS.REGEXMATCH(A${row}, B${row}, C${row})`);
sheet.setFormula(row - 1, 3, `=FORMULATEXT(E${row})`);
}
}
let createDataValidations = function (sheet, row) {
let false_dv = GC.Spread.Sheets.DataValidation.createFormulaValidator("IF(E" + (row + 1) + ",TRUE,FALSE)");
false_dv.highlightStyle({ type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar, color: "pink", position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft });
sheet.setDataValidator(row, 4, 1, 1, false_dv, 3);
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);